package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.ReceiptsStatus;
import com.zhongshu.reward.client.type.ReceiptsType;
import com.zswl.cloud.bdb.client.vo.InviteReceiptsRoleVo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;

import java.math.BigDecimal;

/**
 * 到账记录
 * @author wjf
 * @date 2024/8/5
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class WalletReceipts extends SuperEntity {

    /**
     * 钱包
     */
    @DBRef(lazy = true)
    private Wallet wallet;

    /**
     * 邀请人id
     */
    @Indexed
    private String inviteUserId;

    /**
     * 被邀请人id
     */
    @Indexed
    private String userId;

    /**
     * 预计到账时间
     */
    @Indexed
    private Long estimatedTime;

    /**
     * 实际到账时间
     */
    @Indexed
    private Long receiptsTime;

    /**
     * 到账类型
     */
    @Indexed
    private ReceiptsType receiptsType;

    /**
     * 到账金额
     */
    private BigDecimal total = BigDecimal.ZERO;

    /**
     * 状态
     */
    @Indexed
    private ReceiptsStatus status;

    /**
     * 外部订单号(邀请返利：套餐code, 商品返利：订单号)
     */
    @Indexed
    private String outTradeNo;

    /**
     * 外部订单号(商品返利：商品id:对应产品库id)
     */
    @Indexed
    private String goodsId;

    /**
     * 对应支付中心业务id
     */
    @Indexed
    private String paymentGoodsId;

    /**
     * 产生入账的订阅消息
     */
    @Indexed
    private VipUserRecord vipUserRecord;

    /**
     * 产生入账是匹配的规则
     */
    @Indexed
    private InviteReceiptsRoleVo ruler;

    /**
     * 附加信息
     */
    private Object attach;
}
