package com.zhongshu.reward.server.core.util.ext;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.util.CollectionUtils;
import redis.clients.jedis.GeoCoordinate;
import redis.clients.jedis.resps.GeoRadiusResponse;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: wy
 * @Date: 2023/6/8 16:02
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class GeoRadiusResponseExt {

    private String member;
    private double distance;
    private GeoCoordinate coordinate;

    public static List<GeoRadiusResponseExt> toExt(List<GeoRadiusResponse> params) {
        List<GeoRadiusResponseExt> result = new ArrayList<>();
        if (!CollectionUtils.isEmpty(params)) {
            for (GeoRadiusResponse param : params) {
                GeoRadiusResponseExt ext = new GeoRadiusResponseExt();
                ext.setCoordinate(param.getCoordinate());
                ext.setDistance(param.getDistance());
                ext.setMember(param.getMemberByString());
                result.add(ext);
            }
        }
        return result;
    }
}
